library dart_transducers;

Function compose(Function a, Function b) {
  return (items) => a(b(items));
}

Function filter(Function fn) {
  return (items) {
    var result = [];
    
    items.forEach((item) {
      if (fn(item)) {
        result.add(item);
      }  
    });
    return result;
  };
}

Function map(Function fn) {
  return (items) {
    var result = [];
    items.forEach((item) => result.add(fn(item)));
    return result;
  };
}